;=========================================================================
;Matrix Key
;=========================================================================
MatScan:
	mvl	11100000b
	mvf	VKey,F,ACCE
	
MatScan_Loop:
	mvf	VKey,W,ACCE
	mvf	MatrixKey,F,ACCE
	mvl	00001111b
	andf	MatrixKey,W,ACCE
	xorl	00001111b
	btsz	STATUS,Z,ACCE
	jmp	MatScan_NextLOOP
	call	Delay10ms
	mvl	00001111b
	andf	MatrixKey,W,ACCE
	mvf	HKey,F,ACCE
	xorl	00001111b
	btss	STATUS,Z,ACCE
	jmp	MatScan_HASKEY
MatScan_NextLOOP:
	mvl	00001000b
	iorf	VKey,F,ACCE
	bcf	status,C,ACCE
	rlfc	VKey,F,ACCE
	btsz	status,C,ACCE
	jmp	MatScan_Loop
MatScan_NoKey:
	mvl	0FFh		
	mvf	KeyStill,F,ACCE
	mvf	KeyMatrix,F,ACCE
	jmp	MatScan_End	
;=============================	
MatScan_HASKEY:		
	swpf	VKey,F,ACCE
	mvl	0
  MatScan_KeyVA:	
	rrfc	VKey,F,ACCE
	btss	Status,C,ACCE
	jmp	MatScan_KeyVK
	addl	4
	jmp	MatScan_KeyVA	
  MatScan_KeyVK:	
	mvf	KeyMatrix,F,ACCE
	mvl	0
  MatScan_KeyHA:	
	rrfc	HKey,F,ACCE
	btss	Status,C,ACCE
	jmp	MatScan_KeyHK
	addl	1
	jmp	MatScan_KeyHA
  MatScan_KeyHK:	
	addf	KeyMatrix,F,ACCE
	mvf	KeyMatrix,W,ACCE
	xorf	KeyStill,W,ACCE
	btsz	status,Z,ACCE
	jmp	MatScan_StillEnd
	mvff	KeyMatrix,KeyStill
;=============================	
MatScan_End:		
	ret
MatScan_StillEnd:
	mvl	0FFh
	mvf	KeyMatrix,F,ACCE
	ret	
;==========================================================================================================	
NormalKey:
	mvl	016h
	cpsl	KeyMatrix,ACCE
	retl	0FFh
	mvl     High  NormalKeyPro              ; PCLATH sD_l}(bit 15~8)
	mvf     PCLATH,F,ACCE
	mvf     KeyMatrix,W,ACCE
	addl    Low   NormalKeyPro              ; ոDȻP JPBmۥ[O_WL0x100
	jnc     NormalKeyProM
	inf     PCLATH,F,ACCE         ; pGWL0x100h [PCLATU,PCLATH] + 1
    NormalKeyProM:    
	mvl     NormalKeyPro
	addf    KeyMatrix,W,ACCE
	mvf     PCLATL,F,ACCE         ; ePCLATL + D
NormalKeyPro:
	retl	0Ah
	retl	03h
	retl	02h
	retl	01h
	retl	0Bh
	retl	06h
	retl	05h
	retl	04h
	retl	0Ch
	retl	09h
	retl	08h
	retl	07h
	retl	0Dh
	retl	0Eh
	retl	0Fh
	retl	00h

;       btsz    KeyPT,bK1,ACCE
;       jmp     KScan_Key1
;       call    Delay10ms
;       btsz    KeyPT,bK1,ACCE
;       jmp     KScan_Key1
;       btsz    KeyStill,0,ACCE
;       jmp     KScan_Keyout
;       bsf     KeyStill,0,ACCE
;       call    CKOVZero
;       btsz    WREG,0,ACCE
;       jmp     KScan_Key01
;       call    ShowZero
;       bsf     RLCDG,b_zero,ACCE
;       jmp     KScan_Key02
;      KScan_Key01:
;       call    CKOVMax
;       btsz     WREG,0,ACCE
;       jmp     KScan_Keyout
;       call     ShowTare
;       bsf     RLCDG,b_ltare,ACCE
;      KScan_Key02:
;       ; call    ReLoadADBUF 
;	mvl	256-3
;         mvf   ADStbcnt,F,acce
;       bcf     ADCFg,b_stable,ACCE
;    KScan_Key00:   
;       call    GetADC
;       btss    ADCFg,b_ADCOK,ACCE
;       jmp     KScan_Key00
;       bcf     ADCFg,b_ADCOK,ACCE
;       btss    ADCFg,b_stable,ACCE 
;       jmp     KScan_Key00
;       btss    RLCDG,b_zero,ACCE
;       jmp     KScan_Key03
;       mvff    ADCOUTL,Zero              
;       mvff    ADCOUTM,Zero+1              
;       mvff    ADCOUTH,Zeroh              
;       jmp     KScan_Keyout
;      KScan_Key03:
;       mvff    ADCOUTL,Tare              
;       mvff    ADCOUTM,Tare+1              
;       mvff    ADCOUTH,TareH              
;       jmp     KScan_Keyout
;   ;-------------------    
;   KScan_Key1:
;       btsz    KeyPT,bK2,ACCE
;       jmp     KScan_Key2
;       call    Delay10ms
;       btsz    KeyPT,bK2,ACCE
;       jmp     KScan_Key2
;       btsz    KeyStill,1,ACCE
;       jmp     KScan_Keyout
;       bsf     KeyStill,1,ACCE
;       btss    Flag,b_ADS,ACCE
;       jmp     KScan_Key11
;       bcf     Flag,b_ADS,ACCE
;       jmp     KScan_Key12
;   KScan_Key11:
;       bsf     Flag,b_ADS,ACCE
;   KScan_Key12:    
;       jmp     KScan_Keyout
;   ;-------------------    
;   KScan_Key2:    
;       btsz    KeyPT2,bK3,ACCE
;       jmp     KScan_NoKey
;       call    Delay10ms
;       btsz    KeyPT2,bK3,ACCE
;       jmp     KScan_NoKey
;       btsz    KeyStill,2,ACCE
;       jmp     KScan_Key2still
;       bsf     KeyStill,2,ACCE
;       jmp     KScan_Keyout
;    ;   btsz    KeyStill,4,ACCE
;    ;   jmp     KScan_Key21
;    ;   bsf     keyStill,4,ACCE
;    ;   bcf     PT1DA,2,ACCE
;    ;   call    ClearLCD
;    ;   mvl     LCDNUMS
;    ;   mvf     LCD3,F,ACCE
;    ;   mvl     LCDNUMP
;    ;   mvf     LCD4,F,ACCE
;    ;   mvl     LCDNUMi
;    ;   mvf     LCD5,F,ACCE
;    ; KScan_Key23:  
;    ;   mvl     200
;    ;   mvf     Tm,F,ACCE
;    ; KScan_Key22:  
;    ;   tfsz    Tm,ACCE
;    ;   jmp     KScan_Key22    
;    ;   jmp     KScan_Keyout
;    ;  KScan_Key21: 
;    ;    bcf    KeyStill,4,ACCE
;    ;    bsf     PT1DA,2,ACCE
;    ;   call    ClearLCD
;    ;   mvl     LCDNUMB
;    ;   mvf     LCD3,F,ACCE
;    ;   mvl     LCDNUMA
;    ;   mvf     LCD4,F,ACCE
;    ;   mvl     LCDNUMt
;    ;   mvf     LCD5,F,ACCE
;    ;   jmp     KScan_Key23    
;    KScan_Key2still:
;        btsz   KeyStill,5,ACCE
;        jmp    KScan_Key2s1
;        bsf    KeyStill,5,ACCE
;        bcf    KeyStill,6,ACCE
;        mvl    200
;        mvf    Tm,F,ACCE
;        jmp    KScan_Keyout
;      KScan_Key2s1:       
;        tfsz   Tm,ACCE
;        jmp    KScan_Keyout
;        btsz   KeyStill,6,ACCE
;        jmp    KScan_Key2s2
;        bsf    KeyStill,6,ACCE
;        mvl    200
;        mvf    Tm,F,ACCE
;        jmp    KScan_Keyout
;       KScan_Key2s2: 
;       jmp     Main_Sleep
;   KScan_NoKey:  
;       mvl     0F0h
;       andf     KeyStill,F,ACCE
;        bcf    KeyStill,5,ACCE
;   KScan_Keyout:
