;========================================================================================
; ADC output 122 Hz
; X32SINC3  3.8hzX
; n bit 0 ~ bit 38
; L bit 15 ~ bit 38
; IZALBIZAMBIZAHBIZAUBIZAY ' nȦs1
; IZBLBIZBMBIZBHBIZBUBIBAY ' nȦs2
; IZCLBIZCMBIZCHBIZCUBICAY ' nȦs3
; DZALBDZAMBDZAH ' LȦs1
; DZBLBDZBMBDZBH ' LȦs2
; DZCLBDZCMBDZCH ' LȦs3
;========================================================================================
         btss   INTF1,ADCIF,ACCE
         jmp    Inter_3_out
         bcf    INTF1,ADCIF,ACCE
         
	lbsr	IZAL
	mvf	ADC0RL,W,ACCE	;n1 + ADC --> n1 
	addf	IZAL,F,BANK
	mvf	ADC0RM,W,ACCE
	addc	IZAM,F,BANK
	mvf	ADC0RH,W,ACCE
	addc	IZAH,F,BANK
	mvl	0
	btsz	ADC0RH,7,ACCE
	mvl	0FFh
	addc	IZAU,F,BANK
	addc	IZAY,F,BANK
	
	mvf	IZAL,W,BANK	;n1 + n2 --> n2
	addf	IZBL,F,BANK
	mvf	IZAM,W,BANK
	addc	IZBM,F,BANK
	mvf	IZAH,W,BANK
	addc	IZBH,F,BANK
	mvf	IZAU,W,BANK
	addc	IZBU,F,BANK
	mvf	IZAY,W,BANK
	addc	IZBY,F,BANK
	
	mvf	IZBL,W,BANK	;n2 + n3 --> n3
	addf	IZCL,F,BANK
	mvf	IZBM,W,BANK
	addc	IZCM,F,BANK
	mvf	IZBH,W,BANK
	addc	IZCH,F,BANK
	mvf	IZBU,W,BANK
	addc	IZCU,F,BANK
	mvf	IZBY,W,BANK
	addc	IZCY,F,BANK

	inf	ADCCnter,W,ACCE	; ֥[32
	mvl	31
	cpsl	ADCCnter,ACCE
	jmp	INTER_DVIN
	inf	ADCCnter,F,ACCE
	jmp	Inter_3_out
;================================	
INTER_DVIN:
;	btgf	PT2,7,ACCE
	mvl	0C0h	
	andf	ADCCnter,F,ACCE
INTER_DVOU:	
	mvff	IZCL,BIOUL	;n3  --> Buffer	
	mvff	IZCM,BIOUM	
	mvff	IZCH,BIOUH	
	mvff	IZCU,BIOUU	
	mvff	IZCY,BIOUY	

	bsf	ADCFg,b_ADCint,ACCE
	bsf	Flag,b_ADCPCOK,ACCE
	lbsr	DZAL
	mvl	7		;BufferBit 15 ~ 38
LINTER_DVOULOOP:	
	bcf	Status,C,ACCE
	rrfc	BIOUY,F,BANK
	rrfc	BIOUU,F,BANK
	rrfc	BIOUH,F,BANK
	rrfc	BIOUM,F,BANK
	rrfc	BIOUL,F,BANK
	dcsz	WREG,F,ACCE
	jmp	LINTER_DVOULOOP
		
	mvf	DZAL,W,BANK	; Buffer - L1 --> BufferA
	subf	BIOUM,W,BANK
	mvf	BADCOL,F,BANK
	mvf	DZAM,W,BANK
	subc	BIOUH,W,BANK
	mvf	BADCOM,F,BANK
	mvf	DZAH,W,BANK
	subc	BIOUU,W,BANK
	mvf	BADCOH,F,BANK
	mvff	BIOUM,DZAL	; Buffer --> L1
	mvff	BIOUH,DZAM
	mvff	BIOUU,DZAH
	
	mvf	DZBL,W,BANK	; BufferA - L2 --> BufferB
	subf	BADCOL,W,BANK
	mvf	BBBADNEWL,F,BANK	
	mvf	DZBM,W,BANK
	subc	BADCOM,W,BANK	
	mvf	BBBADNEWM,F,BANK	
	mvf	DZBH,W,BANK
	subc	BADCOH,W,BANK	
	mvf	BBBADNEWH,F,BANK	
	mvff	BADCOL,DZBL	; BufferA --> L2
	mvff	BADCOM,DZBM
	mvff	BADCOH,DZBH
	
	mvf	DZCL,W,BANK	; BufferB - L2 --> BufferA
	subf	BBBADNEWL,W,BANK
	mvf	BADCOL,F,BANK	
	mvf	DZCM,W,BANK
	subc	BBBADNEWM,W,BANK
	mvf	BADCOM,F,BANK	
	mvf	DZCH,W,BANK
	subc	BBBADNEWH,W,BANK
	mvf	BADCOH,F,BANK	
	mvff	BBBADNEWL,DZCL	; BufferB --> L3
	mvff	BBBADNEWM,DZCM
	mvff	BBBADNEWH,DZCH

	mvff	BADCOH,BADNEWH ; ̫BufferBXADC Output
	mvff	BADCOM,BADNEWM
	mvff	BADCOL,BADNEWL
;=========================================================================================
;;
;; For PC Test
         btss   RAMFg,b_Regsp,ACCE
         jmp    GETADC_ADCFlashPRO
         btsz   RAMFg,b_Regspbg,ACCE
         jmp    GETADC_ADCSTPPRO
      Int_ADCSTPPR0:   
         lbsr   STEPBF
         clrf   STEPBF,BANK
      Int_ADCSTPPR1:   
         mvff   STEPLEN,STEPLENBF
         lbsr   STEPBF
         bcf    STATUS,C,ACCE
         rlfc   STEPBF,W,BANK
         bcf    STATUS,C,ACCE
         rlfc   WREG,F,ACCE
         bcf    STATUS,C,ACCE
         rlfc   WREG,F,ACCE
         addl   REGData0
         mvf    FSR1L,F,ACCE
         mvl    HIGH REGData0
         mvf    FSR1H,F,ACCE
         clrf   FSR0H,ACCE
         lbsr   Steptemp
         clrf   Steptemp,BANK
    GETADC_ADCSTPBGLOP:     
         mvl    REGAddr
         addf   Steptemp,W,BANK
         mvf    FSR0L,F,ACCE
         mvl    HIGH REGAddr
         mvf    FSR0H,F,ACCE
         mvf    INDF0,W,ACCE
         mvf    FSR0L,F,ACCE
         clrf   FSR0H,ACCE
        ; mvff   REGAddr,FSR0L
         mvff   POINC1,INDF0 
        ; mvff   REGAddr,FSR0L
         inf    StepTemp,F,BANK
         btss   Steptemp,3,BANK
         jmp    GETADC_ADCSTPBGLOP
         btsz   RAMFg,b_Regspbg,ACCE
         jmp    GETADC_ADC_WDF
         bsf    RAMFg,b_Regspbg,ACCE
         bcf    RAMFg,b_Regspok,ACCE
         jmp    GETADC_3_out
     GETADC_ADCSTPPRO:
         lbsr   STEPLENBF
         dcsz   STEPLENBF,F,BANK
         jmp    GETADC_ADC_WDF
         inf    STEPBF,F,BANK
         mvf    STEP,W,BANK
         cpse   STEPBF,BANK
         jmp    Int_ADCSTPPR1
         mvl    1
         subf   LOOPLEN,F,BANK
         mvl    0
         subc   LOOPLEN+1,F,BANK
         tfsz   LOOPLEN+1,BANK
         jmp    Int_ADCSTPPR0
         tfsz   LOOPLEN,BANK
         jmp    Int_ADCSTPPR0
         bsf    RAMFg,b_Regspok,ACCE
         bcf      RAMFg,b_Regsp,ACCE
         jmp    GETADC_ADC_WDF
         ;jmp    GETADC_3_out
;---------
   GETADC_ADCFlashPRO:
         btss   Flag,b_FlashW,ACCE
         jmp    GETADC_ADCNX
         lbsr   FlashGvup
         tfsz   FlashGvup,BANK
         jmp    GETADC_ADCFlashGV
         jmp    GETADC_ADCFlash
      GETADC_ADCFlashGV:   
         dcsz   FlashGvup,F,BANK
         jmp    GETADC_3_out
      GETADC_ADCFlash:   
         lbsr   FlashLen
         btss   FlashLen+2,7,BANK
         jmp    GETADC_ADCNX1
        GETADC_ADCNXOUT: 
         bsf    Flag,b_FlashOK,ACCE
         jmp    GETADC_3_out
      GETADC_ADCNX1:
         mvl     0
         cpse    FlashLen+2,BANK
         jmp     GETADC_ADCNX2
         cpse    FlashLen+1,BANK
         jmp     GETADC_ADCNX2
         cpse    FlashLen,BANK
         jmp     GETADC_ADCNX2
         jmp     GETADC_ADCNXOUT
     GETADC_ADCNX2:    
         jmp    GETADC_ADC_WDF
      GETADC_ADCNX:   
         btss   RSTX,b_ADCcnn,ACCE
         jmp    GETADC_ADC_A
         tfsz   GvupADC,ACCE
         jmp    GETADC_ADC_w1
         jmp    GETADC_ADC_w3
      GETADC_ADC_w1:   
         insz   GvupADC,F,ACCE
         jmp    GETADC_ADC_A
      GETADC_ADC_w3:   
         mvff   RAMBKL,FSR0L
         mvff   RAMBKH,FSR0H
         LBSR	BADNEWL
         mvf    BADNEWL,W,BANK
         mvf    POINC0,F,ACCE
         mvf    BADNEWM,W,BANK
         mvf    POINC0,F,ACCE
         mvf    BADNEWH,W,BANK
         mvf    POINC0,F,ACCE
         mvl    1
         cpse   FSR0H,ACCE
         jmp    GETADC_ADC_w2
         mvl    7Dh
         cpsg   FSR0L,ACCE
         jmp    GETADC_ADC_w2
         mvl    1
         mvf    FSR0H,F,ACCE
         mvf    RAMBKH,F,ACCE
         clrf   FSR0L,ACCE
         clrf   RAMBKL,ACCE 
         bcf     RSTX,b_ADCcnn,ACCE
         mvl      256-3 
         mvf      GvupADC,F,ACCE
         jmp    GETADC_3_out
       GETADC_ADC_w2:  
         mvff   FSR0L,RAMBKL
         mvff   FSR0H,RAMBKH
    ;-------------------------     
    GETADC_ADC_A:     
         btsz   RSTX,b_ADCbg,ACCE
         jmp    GETADC_ADC_WDF
       mvl     low  SaveData
       mvf     RAMClient,F,ACCE
       mvf     RAMStart,F,ACCE
         
         jmp     GETADC_3_2
      GETADC_ADC_WDF:   
         bcf    RAMFg,bClient,ACCE
         bcf    RAMFg,bClient1,ACCE
         mvf    RAMStart,W,ACCE
         subf   RAMClient,W,ACCE
         btss   status,c,ACCE
         addl   SaveDataend - SaveData + 1
         addl   256 - SaveDataend + SaveData + 1       
         btsz   status,c,ACCE
         jmp    ttt
      GETADC_3_Loop:        
         mvf    RAMClient,W,ACCE
         mvf    FSR0L,F,ACCE
         mvl    High  SaveData
         mvf    FSR0H,F,ACCE
         btsz   RAMFg,bClient1,ACCE
         jmp    GETADC_ADC_SA
	lbsr	BADNEWL

         mvf    BADNEWL,W,BANK
         btsz   RAMFg,bClient,ACCE
         mvf    BADNEWM,W,BANK
         jmp    GETADC_ADC_SB
       GETADC_ADC_SA:
         mvf    BADNEWH,W,BANK
       GETADC_ADC_SB:  
         mvf    INDF0,F,ACCE
         inf    RAMClient,F,ACCE
         mvl    LOW  SaveData
         subf   RAMClient,W,ACCE
         addl   256 - SaveDataend + SaveData - 1       
         btss   status,c,ACCE
         jmp    GETADC_3_1
         mvl    LOW  SaveData
         mvf    RAMClient,F,ACCE
     GETADC_3_1: 
         btsz   RAMFg,bClient1,ACCE
         jmp    GETADC_ADC_SC
         btsz   RAMFg,bClient,ACCE
         jmp    GETADC_ADC_SD
         bsf    RAMFg,bClient,ACCE
         jmp    GETADC_3_Loop
       GETADC_ADC_SD:
         bsf    RAMFg,bClient1,ACCE
         jmp    GETADC_3_Loop
     GETADC_ADC_SC:
         btss   Flag,b_FlashW,ACCE
         jmp    GETADC_3_2
         mvl     3
         subf    FlashLen,F,BANK
         mvl     0
         subc    FlashLen+1,F,BANK
         subc    FlashLen+2,F,BANK  
         jmp     GETADC_3_2
       ttt:  
          nop
      GETADC_3_2:   
 GETADC_3_out:      
	;bsf    RSTX,b_ADCkn,ACCE
	;btsz   RAMFg,b_Regsp,ACCE
	;RET
	;btsz   RSTX,b_ADCcnn,ACCE
	;RET
	;btsz   RSTX,b_ADCbg,ACCE
	;RET
	;btsz   Flag,b_FlashW,ACCE
	;RET

Inter_3_out:    
