SysInit:
       mvl     00000001b
       mvf     MCKCN1,F,ACCE
       mvl     00000011b
       mvf     SSPCON1,F,ACCE
       mvl     00010111b
       mvf     SVSCN,F,ACCE
 ;==========Setup VDDA=======================================
       mvl     11110000b
       mvf     PWRCN,F,ACCE    
 ;==============Clear Memory=======================      
       ldpr    080h,FSR0
       mvl     080h
    ClriniMen0:   
       clrf    POINC0,ACCE
       dcsz    WREG,F,ACCE
       jmp     ClriniMen0
       ldpr    100h,FSR0
       mvl     80h
    ClriniMen1:   
       clrf    POINC0,ACCE
       dcsz    WREG,F,ACCE
       jmp     ClriniMen1
       mvl     00000001b
       mvf     MCKCN2,F,ACCE   ; external clock
       mvl     6
       mvf     ADshiftbit,F,ACCE
 ;==========Setup PT1 Interrupt=======================================
       mvl     00110000b
       mvf     PT1,F,ACCE      
       mvl     00000000b     ; Set  Digital Channel
       mvf     PT1DA,F,ACCE
       mvl     10110000b     ; PT1.3 = RX , PT1.4 = TX, PT1.5 = SDO , PT1.6 = SCK , PT1.2 = SDI
       mvf     TRISC1,F,ACCE
       mvl     01001111b
       mvf     PT1PU,F,ACCE  ; Set Pull up Resistor
       mvl     00000100b
       mvf     PT1M2,F,ACCE   
 ;==========Setup PT2 =======================================
       mvl     00000000b
       mvf     PT2,F,ACCE
       mvl     11100000b
       mvf     TRISC2,F,ACCE
       mvl     00011100b
       mvf     PT2PU,F,ACCE 
       call    EndSPI      
 ;==========Setup PT3 =======================================
	mvl	11110000b
	mvf	TRISC3,F,ACCE
	mvl	00001111b
	mvf	PT3PU,F,ACCE
	mvl	11111111b
	mvf	PT3,F,ACCE 
 ;==========Setup ADC0=======================================
       mvl     00011110b
       mvf     ADC0CN1,F,ACCE
       mvl     00001101b
       mvf     ADC0CN2,F,ACCE
       mvl     01100000b	;128Hz output
       mvf     ADC0CN3,F,ACCE
       mvl     01101100b
       mvf     AINET1,F,ACCE
       mvl     01000100b
       mvf     AINET2,F,ACCE
       mvl     01h
       mvf     RAMBKH,F,ACCE
       mvl     00h
       mvf     RAMBKL,F,ACCE
 ;==========Set Timmer=======================================
       bsf     MCKCN3,PERCK,ACCE   ; Select clock source = HS clock / 32      
       mvl     11000000b
       mvf     TMACN,F,ACCE     
 ;==========Set LCD=======================================
       call    ClearLCD
 ;==========Set Timmer=======================================
       clrf    status,ACCE
       lbsr    1
       clrf    FlashAddr,BANK
       clrf    FlashAddr+1,BANK
       clrf    FlashAddr+2,BANK
       clrf    PCLATH,ACCE
       bcf     Flag,b_FlashW,ACCE
       bcf     Flag,b_FlashOK,ACCE
       bcf     Flag,b_FlashEr,ACCE
    ;=============SPI Setup====================================   
       mvl     high SPIDATA
       mvf     SPIINDEXH,F,ACCE
       mvl     Low SPIDATA
       mvf     SPIINDEXL,F,ACCE
       clrf    SSPSTA,ACCE
       clrf    SPICNT,ACCE
       mvl     0FFh
       mvf     SSPBUF,F,ACCE
       clrf    SPICNT,ACCE
       bsf     SSPCON1,SSPEN,ACCE
      ;=========UART====================== 
      ;==========INTE Set============================
       mvl       01001010b
       mvf       INTE1,F,ACCE
       mvl       00000100b      ; RCIE,SSPIE
       mvf       INTE2,F,ACCE
      ;======================================
       mvl      256-3 
       mvf      GvupADC,F,ACCE
       clrf      Temp,ACCE
       clrf      Temp+1,ACCE
       mvl     low  SaveData
       mvf     RAMClient,F,ACCE
       mvf     RAMStart,F,ACCE
      clrf      INTF2,ACCE
      clrf      INTF1,ACCE   
      clrf      RSTX,ACCE    
         clrf     SPICNT,ACCE    ;
         mvl     0A0h
         mvf     eecnt,F,ACCE
         mvl     256-5
         mvf    ADStbcnt,F,acce
       bsf     ADCFg,b_nonevalue,ACCE
       
       call     delay10ms
      ; mvl     00100101b
      ; mvf     ADCSET,F,ACCE
       bsf      ADC0CN1,ENADC,ACCE
        mvl     1
        mvf     sn,F,ACCE
        
       btsz    KeyPT,bK1,ACCE
       jmp     Sysini_1
       call    Delay10ms
       btsz    KeyPT,bK1,ACCE
       jmp     Sysini_1
     SysADCCAL:  
       call    Delay10ms
       call    Delay10ms
       call    Delay10ms
       jmp     Sysiniout
   Sysini_1:    
        mvl    00h
        mvf    eeaddress,F,ACCE
        mvl    2
        mvf    s_reg_EE,F,ACCE
        mvl    HIGH  temp 
        mvf    fsr0H,F,ACCE
        mvl    temp
        call   eerdblk
        
        mvl    0A5h
        cpse   temp,ACCE
        jmp    SysADCCAL
        mvl    05Ah
        cpse   temp+1,ACCE
        jmp    SysADCCAL
        bcf    ADCFg,b_nonevalue,ACCE
        mvl    010h
        mvf    eeaddress,F,ACCE
        mvl    11
        mvf    s_reg_EE,F,ACCE
        mvl    HIGH  UWeight 
        mvf    fsr0H,F,ACCE
        mvl    UWeight
        call   eerdblk
        mvl    020h
        call   eeread
        mvf    eedatemp,W,ACCE
        mvf    ADshiftbit,F,ACCE
        mvl     4
        mvf     Temp+5,F,ACCe
        mvl      Temp+5
        mvf      md1,F,ACCE
        mvl      CWeight
        mvf      md2,F,ACCE
        mvl      Temp
        mvf      md3,F,ACCE
        mvl      1
        mvf      mdl1,F,ACCE
        mvl      2
        mvf      mdl2,F,ACCE
        lbsr     Temp
        call     multiply
	swpf	ADPoint,W,ACCE
	andl	0Fh
	mvf	Temp+7,F,ACCE
	mvl	adspan
	mvf	md1,F,ACCE
	mvl	Temp+7	
	mvf	md2,F,ACCE
	mvl	Temp+3
	mvf	md3,F,ACCE
	mvl	3
	mvf	mdl1,f,acce
	mvl	1
	mvf	mdl2,F,ACCE
	call	multiply
	mvff	temp+3,adspan
	mvff	temp+3+1,adspan+1
	mvff	temp+3+2,adspan+2
	mvff	temp+3+3,adspan+3
	
        ;mvff     adspan,temp+3        
        ;mvff     adspan+1,temp+3+1
        ;mvff     adspanH,temp+3+2
        mvl     Temp+3
        mvf     md1,F,ACCE
        mvl     temp
        mvf     md2,F,ACCE
        mvl     temp+7
        mvf     md3,F,ACCE
        mvl     4
        mvf     mdl1,F,ACCE
        mvl     3
        mvf     mdl2,F,ACCE
        mvl     1
        mvf     mdl3,F,ACCE
        lbsr     Temp
        call    divide
        mvl     1
        cpsg    temp+7,ACCE
        jmp      Sysini_5
        mvff    temp+7,sn       
     Sysini_5: 
     ;---- max  +9d
       swpf     ADPoint,ACCE
       andl    0Fh
       mull     9
        mvf     PRODL,W,ACCE
        addf    UWeight,W,ACCE
        mvf     temp+3,F,ACCE
        mvl     0
        addc    UWeight+1,W,ACCE
        mvf     Temp+3+1,F,ACCE
        mvff    adspan,temp
        mvff    adspan+1,temp+1
        mvff    adspanh,temp+2
        mvl     temp
        mvf     md1,F,ACCE
        mvl     Temp+3
        mvf     md2,F,ACCE
        mvl     temp+5
        mvf     md3,F,ACCE
        mvl     3
        mvf     mdl1,F,ACCE
        mvl     2
        mvf     mdl2,F,ACCE
        call    multiply
        mvl     Temp+5
        mvf     md1,F,ACCE
        mvl     CWeight
        mvf      md2,F,ACCE
        mvl     Temp
        mvf     md3,F,ACCE
        mvl    5
        mvf    mdl1,F,ACCE
        mvl    2
        mvf     mdl2,F,ACCE
        mvl    3
        mvf     mdl3,F,ACCE
        call    divide
        mvff    Temp,ADCMax
        mvff    Temp+1,ADCMax+1
        mvff    Temp+2,ADCMaxH
        ;--- 1/10 max
        mvl     10
        mvf     temp+3,F,ACCE
        mvl     temp
        mvf     md1,F,ACCE        
        mvl     temp+3
        mvf     md2,F,ACCE        
        mvl     Temp+4
        mvf     md3,F,ACCE        
        mvl     3
        mvf     mdl1,F,ACCE
        mvl     1
        mvf     mdl2,F,ACCE
        mvl     3
        mvf     mdl3,F,ACCE
        call    divide
        mvff    Temp+4,PreZero
        mvff    Temp+4+1,PreZero+1
        mvff    Temp+4+2,PreZeroH
        
        bsf     INTE1,GIE,ACCE
        mvl    9
        mvf    Temp+9,F,ACCE
   Sysini_2:    
       btsz    KeyPT,bK1,ACCE
       jmp     Sysini_6
       call    Delay10ms
       btsz    KeyPT,bK1,ACCE
       jmp     Sysini_6
       bsf    ADCFg,b_nonevalue,ACCE
       jmp    SysADCCAL
     Sysini_6: 
        mvl     100
        mvf     Tm,F,ACCE
        mvf     Temp+9,W,ACCE
        bcf     status,c,ACCE
        rrfc    WREG,F,ACCE
        call    LDISP
        mvf     TBLDL,W,ACCE
        btss    Temp+9,0,ACCE
        mvf     TBLDH,W,ACCE
        mvf     LCD1,F,ACCE
        mvf     LCD2,F,ACCE
        mvf     LCD3,F,ACCE
        mvf     LCD4,F,ACCE
        mvf     LCD5,F,ACCE
   Sysini_3: 
        call    GetADC
        tfsz    Tm,ACCE
        jmp     Sysini_3
        dcsz    Temp+9,F,ACCE
        jmp     Sysini_2
        call    Delay10ms
       ; call    ReLoadADBUF 
	mvl	256-3
         mvf   ADStbcnt,F,acce
       bcf     ADCFg,b_stable,ACCE
        call    ClearLCD 
   Sysini_4:    
        call    GetADC
       btss    ADCFg,b_ADCOK,ACCE
       jmp     Sysini_4
       bcf     ADCFg,b_ADCOK,ACCE
        btss    ADCFg,b_stable,ACCE 
        jmp     Sysini_4
        mvf     ADCOUTL,W,ACCE
        mvf     adaz,F,ACCE
        mvf     Zero,F,ACCE
        mvf     ADCOUTM,W,ACCE
        mvf     adaz+1,F,ACCE
        mvf     Zero+1,F,ACCE
        mvf     ADCOUTH,W,ACCE
        mvf     adazh,F,ACCE
        mvf     ZeroH,F,ACCE
        bsf     LCD_G,b_lg,ACCE
        bcf     ADCFg,b_Tarem,ACCE
        bcf     ADCFg,b_Zerom,ACCE
       mvl     200
       mvf     Tm1s,F,ACCE
Sysiniout: 
        clrf   KeyStill,ACCE        
       bsf     INTE1,GIE,ACCE  
        bcf    Flag,b_ADS,ACCE
