;=======================================================================
; SPICNT : SPIƶq
;          SPICNT = 0 ==>  SPIBUFBit 7 = 1 Ū , SPIBUFBit 7 = 0 g
;          SPICNT = 1 ==>  SPIBUF = wRAM Address  Low byte  --> FSR0L
;          SPICNT = 2 ==>  SPIBUF = wRAM Address  High byte --> FSR0H
;          SPICNT > 2 ==>   wRAM Address iŪgʧ@
; SPICNTiWL 255
; CS PIN 10  01 |M SPICNT
;=======================================================================
      org   0000h
ProReset:      
         nop
         jmp   ProBegin
         ;jmp   0
      org   0004h
        Include  Interrupt.asm
;======================================================== 
ProBegin: 
       include   SysIni.asm
;==============================================================
        mvl    0E0h
        mvf    SPIINDEXL,F,ACCE
;==============================================================  
MainLoop:
	lbsr	RLCDG
        btsz    SVSCN,SVSOP,ACCE
        bsf     RLCDG,b_lbat,BANK
        btss    SVSCN,SVSOP,ACCE
        bcf     RLCDG,b_lbat,BANK
        btsz     RAMFg,b_FlashR,ACCE
        jmp      MainFlashRd
        btsz     Flag,b_FlashEr,ACCE
        jmp      MainFlashErease
        btsz     Flag,b_FlashW,ACCE
        jmp      MainFlshWr
        btsz     RAMFg,b_Regsp,ACCE
        jmp      MainStep
        btsz  ADCFg,b_nonevalue,ACCE
        jmp   CALADCPRO
        call	MatScan
        include   MainPro.asm
        btss     RSTX,b_rdEEPROM,ACCE
        jmp      MainLoop_1
        call     SPIRWEE
        bcf      RSTX,b_rdEEPROM,ACCE
        bcf      RSTX, b_EEPROMERR,ACCE
        tfsz     WREG,ACCE
        bsf      RSTX, b_EEPROMERR,ACCE
        jmp      MainLoop_2
    MainLoop_1:    
        btss     RSTX,b_wrEEPROM,ACCE
        jmp      MainLoop_2
        call     SPIRWEE
        bcf      RSTX,b_wrEEPROM,ACCE
        bcf      RSTX, b_EEPROMERR,ACCE
        tfsz     WREG,ACCE
        bsf      RSTX, b_EEPROMERR,ACCE
    MainLoop_2:    
       jmp  MainLoop
CALADCPRO:
       btss    KeyPT,bK1,ACCE
       jmp     CALADCPRO
       call    delay10ms
       btss    KeyPT,bK1,ACCE
       jmp     CALADCPRO
       clrf    KeyCnt,ACCE
       call    ClearLCD
       mvl	15
       cpsg	ADshiftbit,ACCE
       jmp	CALADCPRO_1
       mvl	05h
       mvf	ADshiftbit,F,ACCE
 CALADCPRO_1:      
	;call	CALShowCAL
	ldpr	Temp,FSR0
CALADCPROLOOP:	
	clrf	POINC0,ACCE
	mvl	Temp+15
	cpsg	FSR0L,ACCE
	jmp	CALADCPROLOOP
       include   ADCCAL.asm              
;=================================================
MainStep:
MainFlash:
MainFlshWr:
        btsz     RAMFg,b_Regspok,ACCE
        jmp      MainFlshCom1
        btss     Flag,b_FlashOK,ACCE
        jmp      MainFlashWr1
     MainFlshCom1:   
        call    TBufEmpty
        btss    status,z,ACCE
        jmp     MainFlashWr1
       MainFlshCOM3: 
        CALL    EndSPI
       MainFlshCOM2: 
        call    RDFlashSta
        andl    00000001b
        btss    status,z,ACCE
        jmp     MainFlshCOM2
     MainFlshCom:   
        bcf      ptdaem,eedata,ACCE
     MainFlshComXX:   
	lbsr	RLCDG
        bcf      RAMFg,b_Regsp,ACCE
        bcf      Flag,b_FlashW,ACCE
        bcf      RLCDG,b_lozt,BANK
        bsf      RLCDG,b_ldwt,BANK
        bsf      FSPIDIPU,bSPIDI,ACCE
        bsf      FSPIDOPU,bSPIDO,ACCE
        bsf      FSPICKPU,bSPICK,ACCE
        bsf      FSPICSPU,bSPICS,ACCE
        bcf      FSPIDIEN,bSPIDI,ACCE
        ;bcf      FSPIDOEN,bSPIDO,ACCE
        bcf      FSPICKEN,bSPICK,ACCE
        bcf      FSPICSEN,bSPICS,ACCE
        jmp      Mainloop
    MainFlashWr1:
        bcf      FSPIDIPU,bSPIDI,ACCE
        bcf      FSPIDOPU,bSPIDO,ACCE
        bcf      FSPICKPU,bSPICK,ACCE
        bcf      FSPICSPU,bSPICS,ACCE
        bsf      FSPIDIEN,bSPIDI,ACCE
       ; bcf      FSPIDOEN,bSPIDO,ACCE
        bsf      FSPICKEN,bSPICK,ACCE
        bsf      FSPICSEN,bSPICS,ACCE
        call     WRFlash
        tfsz     WREG,ACCE
        jmp      MainFlashWr3
        jmp      MainFlashWr4 
     MainFlashWr3:   
        bsf      RAMFg,b_Regspok,ACCE
        bcf      RAMFg,b_Regsp,ACCE
        jmp      MainFlshCOM3
      MainFlashWr4:  
        bsf      RLCDG,b_lozt,BANK
    MainFlshWr2:
        call     GetADC
        call     ShowADC
        jmp      MainFlshWr

MainFlashRd:
        bcf      FSPIDIPU,bSPIDI,ACCE
        bcf      FSPIDOPU,bSPIDO,ACCE
        bcf      FSPICKPU,bSPICK,ACCE
        bcf      FSPICSPU,bSPICS,ACCE
        bsf      FSPIDIEN,bSPIDI,ACCE
        ;bcf      FSPIDOEN,bSPIDO,ACCE













        bsf      FSPICKEN,bSPICK,ACCE
        bsf      FSPICSEN,bSPICS,ACCE
        call     RdFlash
        bcf      RAMFg,b_FlashR,ACCE
        jmp      MainFlshComXX
MainFlashErease:
        bcf      FSPIDIPU,bSPIDI,ACCE
        bcf      FSPIDOPU,bSPIDO,ACCE
        bcf      FSPICKPU,bSPICK,ACCE
        bcf      FSPICSPU,bSPICS,ACCE
        bsf      FSPIDIEN,bSPIDI,ACCE
        ;bcf      FSPIDOEN,bSPIDO,ACCE
        bsf      FSPICKEN,bSPICK,ACCE
        bsf      FSPICSEN,bSPICS,ACCE
        call     FlashErease
        bcf      Flag,b_FlashEr,ACCE
        jmp      MainFlshComXX
        
;=================================================
Main_Sleep:
        bcf      PT2,5,ACCE     ; Loadcell Power off
        call     ClearLCD
        call     ADCENONSTEP  
        clrf     ADC0CN1,ACCE
        clrf     ADC0CN2,ACCE
        clrf     ADC0CN3,ACCE
        clrf     LCDCN1,ACCE
        clrf     PWRCN,ACCE
        clrf     SVSCN,ACCE
   Main_Sleep1:     
       btss    KeyPT2,bK3,ACCE
       jmp     Main_Sleep1
       call    Delay10ms
       btss    KeyPT2,bK3,ACCE
       jmp     Main_Sleep1
       bsf     INTE1,E0IE,ACCE
       bcf     INTF1,E0IF,ACCE
       slp
       nop
   Main_Sleep2:     
       bcf     INTE1,E0IE,ACCE
       bcf     INTF1,E0IF,ACCE
       btss    KeyPT,bK1,ACCE
       jmp     Main_Sleep2
       call    Delay10ms
       btss    KeyPT,bK1,ACCE
       jmp     Main_Sleep2
       jmp     ProBegin
;=================================================
     include    ADC.asm
;=======================================================================================================              
      include   Math.asm
      Include  H08A.INC
      include  Main.inc
      include  S24CXX.asm
      include   Display.asm
      include   LCDINDX.asm
      include    Subroutine.asm
      include   Keyscan.asm
;======================================================================      
ADCENONSTEP:      
       bcf      ADC0CN1,ENADC,ACCE
       mvl     7    
  ADCENONSTEPLOOP:
       bsf      ADC0CN1,ENADC,ACCE
       bcf      ADC0CN1,ENADC,ACCE
       dcsz    wreg,f,acce
       jmp     ADCENONSTEPLOOP
       ret
;=======================================================================================================   
    END     